#Copyright MJFP
#batsman dot geo at yahoo dot com 
  
  class Module
     def def_advice(meth, &block)
         prev = self.instance_method(meth)
         define_method(meth) do |*a|
             block.call prev.bind(self), *a
         end
     end

     def def_preadvice(meth, &block)
         prev = self.instance_method(meth)
         define_method(meth) do |*a|
             block.call(*a)
             prev.bind(self).call(*a)
         end
     end

     def def_postadvice(meth, &block)
         prev = self.instance_method(meth)
         define_method(meth) do |*a|
             prev.bind(self).call(*a)
             block.call(*a)
         end
     end
 end

 class A
     def foo(*a)
         puts "A#foo #{a.inspect}"
     end
 end
 a = A.new
 a.foo

 class A
     def_advice(:foo) do |prev, *a|
         puts "before"
         prev[*a]
         puts "after"
     end
 end

 puts "--"
 a.foo

 class A
     def_preadvice(:foo) { puts "pre 1" }
     def_postadvice(:foo) { puts "post 1"}
     def_preadvice(:foo) { puts "pre 2" }
 end

 puts "--"
 a.foo
 batsman@tux-chan:/tmp$ ruby aop2.rb
 A#foo []
 
 =begin
 before
 A#foo []
 after
 pre 2
 pre 1
 before
 A#foo []
 after
 post 1
 =end
 