class Array

  # Return an array element at random.
  #
  #   require 'facet/array/at_rand'
  #
  #   [1,2,3,4].at_rand     #=> 1
  #   [1,2,3,4].at_rand     #=> 4
  #   [1,2,3,4].at_rand(1)  #=> [4]
  #   [1,2,3,4].at_rand(3)  #=> [2,2,1]
  #   [1,2,3,4].at_rand(3)  #=> [3,2,4]
  #
#   def at_rand(n=nil, exclusive=false)
#     if n
#       n = n.to_i
#       if exclusive
#         return dup if n >= length
#         return sort_by{Kernel.rand}[0..n]
#       else
#         idx = []
#         n.times do
#           idx << Kernel.rand(self.size)
#         end
#         return values_at(*idx)
#       end
#     else
#       return at( Kernel.rand(self.size) )
#     end
#   end

  def at_rand(n=nil, exclusive=false)
    if n
      return values_at(*rand_index(n, :exclusive))
    else
      return at(Kernel.rand(length))
    end
  end
  alias_method(:at_random, :at_rand)


  def pick(n)
  
  end


  # Return random index or indexes of an array. If a number
  # of indexes _n_ is given, an array of indexes is returned.
  # This in non-exlusive and may pick the same index more than
  # once.
  #
  #   ["a", "b", "c"].rand_index          #=> "a" (or "b", or "c")
  #   ["a", "b", "c"].rand_index(2)       #=> ["a","b"]  
  #   ["a", "b", "c"].rand_index(3)       #=> ["a","b","b"]
  #
  def rand_index(n=nil)
    if n
      n = n.to_i 
      if exclusive
        idx = (0...size).to_a
        return idx if n >= length
        return idx.sort_by{Kernel.rand}.slice(0,n)
      else
        idx = []
        n.times{ idx << Kernel.rand(self.length) }
        return idx
      end
    else
      return Kernel.rand(size)
    end
  end

  # Pick and return a random index or indexes of array.
  # If a number of indexes _n_ is given, an array of indexes
  # is returned. Unlike #rand_index, #pick_index is exclusive
  # and will not pick the same index twice. If _n_ exceeds
  # the size of the array, all elements are returned.
  #
  #   ["a", "b", "c"].pick_index          #=> "a" (or "b", or "c")
  #   ["a", "b", "c"].pick_index(2)       #=> ["a","b"]  
  #   ["a", "b", "c"].pick_index(3)       #=> ["a","b","c"]
  #
  #
  def pick_index(n=nil)
    if n
      n = n.to_i
      idx = (0...size).to_a
      return idx if n >= length
      return idx.sort_by{Kernel.rand}.slice(0,n)
    else
      return Kernel.rand(size)
    end
  end

end

