
class Array

  # Pick out _n_ random elements from the array.
  # If _n_ is not given then picks out a single 
  # element.
  #
  #   require 'facet/array/pick'
  #
  #   a = ["a", "b", "c", "d", "e"]
  #   a.pick             #=> "b"
  #   a                  #=> ["a", "c", "d", "e"]
  #   a.pick(2)          #=> ["a", "e"]
  #   a                  #=> ["c", "d"]
  #
  def pick(n=nil)
    if n
      n = n.to_i
      all = (0..size).to_a
      idx = pick_indexes(n)
      vals = values_at(*idx)
      replace( values_at( *(all - idx) )
      return vals
    else
      i = Kernel.rand(size)
      v = at(i)
      delete_at(i)
      return v
    end
  end

end 
