class Array
  # Like +compact+ but takes an _object_ to be
  # removed rather then just nil. Empty string
  # ("") is the default if no parameter is given.
  #
  #   require 'facet/array/remove'
  #
  #   [1,'a',nil,""].remove         #=> [1,'a',nil]
  #   [1,'a',nil,""].remove(nil)    #=> [1,'a',""]
  #   [1,'a',nil,""].remove('a')    #=> [1,nil,""]
  #
  # This could probably use a little error catching code (todo).
  def remove(object="")
    if object
      delete(object)
    else
      compact
    end
    self
  end
end
