##################
# tc_nlconvert.rb
##################
#$:.unshift File.dirname(Dir.pwd) + "/lib"
require 'test/unit'
require 'ftools'
#require 'ptools'

class TC_FileNLConvert < Test::Unit::TestCase

   @@tfile   = 'test_file.txt'
   @@tfile2  = 'test_file2.txt'
   @@dosfile = 'dos_test_file.txt'
   @@macfile = 'mac_test_file.txt'
   @@nixfile = 'nix_test_file.txt'

   def test_01_method_responds
      assert_respond_to( File, :nl_convert )
   end

   def test_02_constructor
      assert_nothing_raised{ File.nl_convert(@@tfile2) }
      assert_nothing_raised{ File.nl_convert(@@tfile2,@@tfile2) }
      assert_nothing_raised{ File.nl_convert(@@tfile2,@@tfile2,"unix") }
      File.copy(@@tfile,@@tfile2)
   end

   def test_03_dos
      assert_nothing_raised{ File.nl_convert(@@tfile,@@dosfile,'dos') }
      err = "dos file should be larger, but isn't"
      assert_equal(true, File.size(@@dosfile) > File.size(@@tfile),err)
   end
   
   def test_04_nix
      assert_nothing_raised{ File.nl_convert(@@tfile,@@nixfile,'unix') }
      err = "unix file should be the same size (or smaller), but isn't"
      if File::ALT_SEPARATOR
         assert_equal(true, File.size(@@nixfile) >= File.size(@@tfile),err)
      else
         assert_equal(true, File.size(@@nixfile) <= File.size(@@tfile),err)
      end
   end
   
   # May fail on MS Windows - no idea why
   def test_05_mac
      assert_nothing_raised{ File.nl_convert(@@tfile,@@macfile,'mac') }
      err = "mac file should be the same size (or larger), but isn't"
      assert_equal(true, File.size(@@macfile) >= File.size(@@tfile),err)
   end

   def test_06_exceptions
      assert_raises(StandardError){ File.nl_convert(@@tfile,"bogus.txt","blah") }
   end

   def teardown
      [@@dosfile,@@macfile,@@nixfile].each{ |f|
         File.delete(f) if File.exists?(f)
      }
   end
end
