class Array
  # Change the first element.
  #
  #   require 'facet/array/first&last='
  #
  #   a = ["a","y","z"]
  #   a.first = "x"
  #   p a           #=> ["x","y","z"]
  #
  def first=(x)
    self[0] = x
  end
  
  # Alias for unshift, which _pushes_
  # an element onto the front of an array.
  #
  #   require 'facet/array/first&last='
  #
  #   a = ["a","y","z"]
  #   a.first! "x"
  #   p a           #=> ["x","a","y","z"]
  #
  alias_method( :first!, :unshift)
  
  # Change the last element.
  #
  #   require 'facet/array/first&last='
  #
  #   a = [1,2,5]
  #   a.last = 3
  #   p a           #=> [1,2,3]
  #
  def last=(x)
    self[-1] = x
  end
  
  # Alias for push.
  #
  #   require 'facet/array/first&last='
  #
  #   a = [1,2]
  #   a.last! 3
  #   p a           #=> [1,2,3]
  #  
  alias_method( :last!, :push)
  
end
