class Array
  # Returns the middle element of an array, or the element offset
  # from middle if the parameter is given. Even-sized arrays,
  # not having an exact middle, return the middle-right element.
  #
  #   require 'facet/array/middle'
  #
  #   [1,2,3,4,5].middle        #=> 3
  #   [1,2,3,4,5,6].middle      #=> 4
  #   [1,2,3,4,5,6].middle(-1)  #=> 3
  #
  # In other words, If there are an even number of elements the
  # higher-indexed of the two center elements is indexed as 
  # orgin (0).
  def middle(offset=0)
    self.at( (self.length / 2) + offset )
  end
end
