class Array
  # Returns the index range between two elements.
  # If no elements are given, returns the range
  # from first to last.
  #
  #   require 'facet/array/range'
  #
  #   ['a','b','c','d'].range            #=> 0..3
  #   ['a','b','c','d'].range('b','d')   #=> 1..2
  #
  #--
  # This could surely use a little error catching code (todo).
  #++
  def range(a=nil,z=nil)
    if !a
      0..self.length-1
    else
      index(a)..index(z)
    end
  end
  alias_method( :index_range, :range )
end
