class Array
  
  # Produces a hash for an Array, or two arrays.
  #
  # If no parameter is given, to_h expects
  # the receiving array to be associative.
  #
  #   require 'facet/array/to_h'
  #
  #   a1 = [ [:a,1], [:b,2] ]
  #   a1.to_h  #=> { :a=>1, :b=>2 }
  #
  # If an array is given it is considered values
  # and zipped with the receiver, to produce the hash.
  #
  #   a1 = [ :a, :b ]
  #   a2 = [ 1, 2 ]
  #   a1.to_h(a2)  #=> { :a=>1, :b=>2 }
  #
  def to_h(values=nil)
    h = {}
    if values
      keys.size.times{ |i| h[at(i)] = values.at(i) }
    else
      each{ |e| h[e.first] = e.slice(1..-1) }
    end
    return h
  end

end
