#--
# Special thanks to Martin DeMello for helping to develop this.
#++
begin
  require 'carat/functor'
rescue
  class Functor
    def initialize(&func) ; @func = func ; end
    def method_missing(op, *args) ; @func.call(op, *args) ; end
  end
end
module Enumerable
  # Uses a Functor to provide R-like per element 
  # method application.
  #
  #   require 'facet/enumerable/every'
  #
  #   a = [1,2,3]
  #   b = [4,5]
  #
  #   p a.every + 3       => [4,5,6]
  #   p a.every + b       => [5,7]
  #   p a.every.+(b,2)    => [[5,7],[3,4,5]]
  #
  # Note that this method is still undergoing some fine tuning.
  # It is questionable as to whether different sized arrays should 
  # be padded with nil (or a parameter) and whether multiple parameters
  # are a good idea (e.g. <tt>a.%.+(b,2,...)</tt>).
  def every
    #Functor.new(self) do |op,*args|
    Functor.new do |op,*args|
      a = args.collect do |arg|
        if arg.kind_of?(Enumerable)
          ln = ( arg.length > self.length ? self.length : arg.length )
          self[0...ln].zip(arg[0...ln]).collect{ |a,b| a.send(op,b) }
          #self[0...l].zip(arg[0...1]).collect{ |a,b| b ? a.send(op,b) : nil }
        else
          self.collect{ |a| a.send(op,arg) }
        end
      end
      a.flatten! if args.length == 1
      a
    end
  end
end
