require 'fileutils'
module FileUtils
  module_function
  # Attempt to do a normal file link, but fall back
  # to a copy if the link fails.
  def safe_ln(*args)
    if @link_not_supported
      FileUtils.cp(*args)
    else
      begin
        FileUtils.ln(*args)
      rescue Errno::EOPNOTSUPP
        @link_not_supported = true
        FileUtils.cp(*args)
      end
    end
  end
end
