class Hash
  # Returns a new hash built by iterating through each key,value 
  # pair and updating the new hash.
  #
  #   require 'facet/hash/collate'
  #
  #   
  #
  #--
  # Note that this method may get some fine tuning as it
  # currently expects the block to return a "mini-hash"
  # pair -- parhaps an 2-element array woud be better?
  #++
  def collate  # :yield:
    newhash = {}
    each_pair{ |k,v| newhash.update( yield(k,v) ) }
    newhash
  end 

  # In place version of #collate.
  def collate!(&yld)
    replace( collate(&yld) )
  end
end

