class Hash
  # A "smarter" hash#each which iterates through each
  # _value_ if only one block parameter is given.
  #
  #   require 'facet/hash/each'
  #
  #   {:a=>"a", 2=>"b", "x"=>"c"}.each{ |v| puts v }
  #
  # _produces_
  #
  #   a
  #   b
  #   c
  #
  # WARNING! Use with caution. Methods from other libraries 
  # may depend on the old behavior, expecting a two element 
  # array to be passed into a single block argument.
  def each(&yld)
    case yld.arity
    when 0
    when 1
      each_value{|v| yield(v)}
    else
      each_pair{|k,v| yld.call(k,v)}
    end
    self
  end
end
