require 'ostruct'
class Hash
  
  # Turns a hash into a generic object using an OpenStruct.
  #
  #   require 'facet/hash/to_ostruct'
  #
  #   o = { 'a' => 1 }.to_ostruct
  #   o.a  #=> 1
  #
  def to_ostruct
    OpenStruct.new( self )
  end
  
  # Like to_ostruct but recusively objectifies all hash elements as well.
  #
  #   require 'facet/hash/to_ostruct'
  #
  #   o = { 'a' => { 'b' => 1 } }.to_ostruct_recurse
  #   o.a.b  #=> 1
  #
  def to_ostruct_recurse
    o = self.dup
    each_pair do |k,v|
      o[k] = v.to_ostruct_recurse if v.respond_to?( :to_ostruct_recurse )
    end
    OpenStruct.new( o )
  end
  
end 
