require 'facet/matchdata/match'
class MatchData
  # Returns the pre_match from subexpression n.
  #
  #   require 'facet/matchdate/match_from'
  #
  #   md = /x(a)(b)(c)z/.match "123xabcz789"
  #   md.pre_match_from(0)   #=> 123
  #   md.pre_match_from(1)   #=> 123x
  #   md.pre_match_from(2)   #=> 123xa
  #   md.pre_match_from(3)   #=> 123xab
  #   md.pre_match_from(-1)  #=> 123xab
  #
  def pre_match_from(n=0)
    return pre_match if n == 0
    n = length + n if n < 0
    upto = offset(n)[0] - 1
    "#{pre_match}#{match[0...upto]}" #.to_s
  end
  
  # Returns the post_match from subexpression n.
  #
  #   require 'facet/matchdate/match_from'
  #
  #   md = /x(a)(b)(c)z/.match "123xabcz789"
  #   md.post_match_from(0)   #=> 789
  #   md.post_match_from(1)   #=> z789
  #   md.post_match_from(2)   #=> cz789
  #   md.post_match_from(3)   #=> bcz789
  #   md.post_match_from(-1)  #=> bcz789
  #
  def post_match_from(n=0)
    return post_match if n == 0
    n = length + n if n < 0
    downfrom = offset(n)[1] - 1
    "#{match[downfrom..-1]}#{post_match}"
  end
end
