# Creates a method that requires to be overridding.
# If it not overridden and called upon a TypeError
# will be raised.
#
#  require 'facet/module/abstract'
#
#  class C
#    abstract :a
#  end
#
#  c = C.new
#  c.a  #=> Error: undefined abstraction #a
#
class Module
  def abstract( *sym )
    sym.each { |s|
      define_method( s ) { raise TypeError, "undefined abstraction ##{s}" }
    }
  end
end
