class Numeric
  # Allows #succ to take _n_ increments.
  #
  #   require 'facet/numeric/succ'
  #
  #   3.succ(2)  #=> 5
  #
  def succ(n=nil)
    n ||= 1
    self + n
  end
  
  # Provides #pred as the opposite of #succ.
  #
  #   require 'facet/numeric/succ'
  #
  #   3.pred(2)  #=> 1
  #
  def pred(n=nil)
    n ||= 1
    self - n
  end
  
  # Alternate for comparison operator #<=>.
  #
  #   require 'facet/numeric/succ'
  #
  #   3.cmp(1)   #=>  1
  #   3.cmp(3)   #=>  0
  #   3.cmp(10)  #=> -1
  #
  def cmp(other)
    self <=> other
  end
end

class Integer
  # This is needed to allow Integer to look back to
  # its Numeric ancestor for the new definition of #succ.
  remove_method( :succ )
end
