class Object

  # Access to an object's special singleton class.
  #
  #   require 'facet/object/special_class'
  #
  def special_class
    (class << self; self; end)
  end

  # Alias for #special_class.
  #
  #   require 'facet/object/special_class'
  #
  alias_method :singleton_class, :special_class

  # Special singleton class eval.
  #
  #   require 'facet/object/special_class'
  #
  def special_class_eval(&block)
    special_class.class_eval(&block)
  end

  # Alias for #special_class_eval.
  #
  #   require 'facet/object/special_class'
  #
  alias_method :singleton_class_eval, :special_class_eval

  # Special singleton class define method.
  #
  #   require 'facet/object/special_class'
  #
  def define_special_method(meth, &block)
    special_class_eval{ define_method(meth, &block) }
  end
  
  # Alias for #define_special_method.
  #
  #   require 'facet/object/special_class'
  #
  alias_method :define_singleton_method, :define_special_method
  
end 
