begin
  require 'carat/functor'
rescue
  class Functor
    def initialize(&func) ; @func = func ; end
    def method_missing(op, *args) ; @func.call(op, *args) ; end
  end
end
class Object
  # Returns method of a parent class bound to self.
  #
  #   require 'facet/object/supers'
  #
  def super_method(klass, meth)
    raise ArgumentError if ! self.class.ancestors.include?(klass)
    klass.instance_method(meth).bind(self) #.call(*args)
  end
  
  # Call parent class/module methods once bound to self.
  #
  #   require 'facet/object/supers'
  #
  def super_send(klass, meth, *args, &blk)
    raise ArgumentError if ! self.class.ancestors.include?(klass)
    klass.instance_method(meth).bind(self).call(*args, &blk)
  end
  
  # Returns a Functor that allows one to call any parent method directly.
  #
  #   require 'facet/object/supers'
  #
  def supers(klass=self.class.superclass)
    raise ArgumentError if ! self.class.ancestors.include?(klass)
    Functor.new do |meth, *args|  # &blk|
      klass.instance_method(meth).bind(self).call(*args) # ,&blk)
    end
  end
end
