#--
# Thanks dave!
#++
class Proc
  # Returns a new proc that is the functional
  # compostion of two procs, in order.
  #
  #  require 'facet/proc/compose'
  #
  #  a = lambda { |x| x + 4 }
  #  b = lambda { |y| y / 2 }
  #
  #  (a * b).call(4)  #=> 6
  #  (b * a).call(4)  #=> 4
  #
  def compose(other)
    raise ArgumentError, "arity count mismatch" unless arity == other.arity
    #proc{ |*a| self.call(other.call(*a)) }
    proc{ |*a| self.call(*other.call(*a)) }
  end
  alias_method( :*, :compose )
end
