require 'thread'
#--
# Credit for #to_method goes to Forian Gross (flgr).
#--
class Proc
  MethodMutexes = Hash.new do |hash, key|
    hash[key] = Mutex.new
  end
  
  # Creates a local method based on a Proc.
  def to_method(name=nil)
    name ||= "!to_method_temp#{self.id}"
    recv = eval("self", self)
    klass = recv.class
    
    MethodMutexes[klass => name].synchronize do
      begin
        klass.send(:define_method, name, &self)
        return recv.method(name)
      ensure
        klass.send(:remove_method, name) if not name
      end
    end
  end
end

=begin
  # Alternate. I assume this is less "safe" then the above.
  def to_method
    # get the object that this proc is bound to
    obj = eval 'self', self.binding
    # get the virtual class for the object
    obj_class = class << obj; self; end
    proc = self
    # define the method. A normally invalid method name was chosen to minimize
    # the chance of a collision. Store the newly created method away.
    obj_class.instance_eval{define_method(:" ", &proc)}
    method = obj.method(:" ")
    # remove the method, and return it.
    obj_class.instance_eval{remove_method(:" ")}
    method
  end
=end
