class Range
  # Returns a two element array of the relationship
  # between two Ranges.
  #
  # Diagram:
  #
  #     Relationship     Returns
  #
  #   self |-----------|
  #   r    |-----------|    [0,0]
  #
  #   self |-----------|
  #   r     |---------|     [-1,-1]
  #
  #   self  |---------|
  #   r    |-----------|    [1,1]
  #
  #   self |-----------|
  #   r     |----------|    [-1,0]
  #
  #   self |-----------|
  #   r     |-----------|   [-1,1]
  #
  #   etc.
  #
  # Example:
  #
  #   require 'facet/range/umbrella'
  #
  #   (0..3).umbrella(1..2)  #=>  [-1,-1]
  #
  def umbrella(r)
    s = self.first <=> r.first
    e = r.last <=> self.last
    return s,e
  end
end
