class String

  BRA_KET = { '['=>']', '('=>')', '{'=>'}', '<'=>'>' }
  
  # Return a new string embraced by given brakets.
  # If only one bracket char is given it will be placed
  # on either side. 
  #
  #   require 'facet/string/braket'
  #
  #   "wrap me".braket('{')        #=> "{wrap me}"
  #   "wrap me".braket('--','!')   #=> "--wrap me!"
  #
  # And yes, I know, it's spelled "wrong"! ;)
  def braket(bra, ket=nil)
    if ! ket && /^[\[({<]$/ =~ bra
      ket = BRA_KET[$&]
    end
    return "#{bra}#{self}#{ket ? ket : bra}"
  end

  # Inplace version of #braket.
  def braket!(bra, ket=nil)
    self.replace( self.braket(bra, ket) )
  end
  
end
