class String
  
  # Returns an array of characters.
  #
  #   require 'facet/string/chars'
  #
  #   "abc".chars  #=> ["a","b","c"]
  #
  def chars
    self.split(//)
  end
  
  # Returns first n characters.
  #
  #   require 'facet/string/first&last'
  #
  #   "Hello World".first(3)  #=> "Hel"
  #  
  def first_chars(n=1)
    self.slice(0,n)
  end
  
  # Returns last n characters.
  #
  #   require 'facet/string/first&last'
  #
  #   "Hello World".last(3)  #=> "rld"
  #  
  def last_chars(n=1)
    return self if n > self.size
    self.slice(-n, n)
  end

end
