class String
  
  # Scramble the inner characters of words leaving the text still readable 
  # (research at Cambridge University, code by KurtDresner). For example:
  #
  #   Srblamce the iennr cchrteaars of wodrs lvenaig the txet stlil rbeaadle
  #   (rreceash at Cbamigdre Uverintisy, cdoe by KrneruestDr?)
  #
  # Usage:
  #
  #   require 'facet/string/dresner'
  #
  #   "this".dresner   #=>  "tihs"
  #
  def dresner
    self.gsub(/\B\w+\B/){$&.split(//).sort_by{rand}} 
  end
  
  # Inplace version of #dresner method.
  def dresner!
    self.replace(dresner)
  end

end

