class String
  # Like index but returns an array of all index locations.
  # The reuse flag allows the trailing portion of a match to be 
  # reused for subsquent matches.
  #
  #   require 'facet/string/index_all'
  #
  #   "abcabcabc".index_all('a')  #=> [0,3,6]
  #
  def index_all(s, reuse=false)
    ia = []; i = 0
    while (i = self.index(s,i))
      ia << i
      i += (reuse ? 1 : $~.length)
    end
    ia
  end
  #alias_method( :indexes, :index_all )
end
