class String
  
  # Like #index but returns a Range.
  #
  #   require 'facet/string/range'
  #
  #   "This is a test!".rand('test')  #=> 10..13
  #
  def range(s, offset=0)
    if self.index(s, offset)
      return ($~.begin(0))..($~.end(0)-1)
    end
    nil
  end
  
  # Like #index_all but returns an array of Ranges.
  #
  #   require 'facet/string/range'
  #
  #   "abc123abc123".range_all('abc')  #=> [0..2, 6..8]
  #
  #--
  # Note: should add offset ?
  #++
  def range_all(s, reuse=false)
    r = []; i = 0
    while i < self.length
      rng = range(s, i)
      if rng
        r << rng
        i += reuse ? 1 : rng.end + 1
      else
        break
      end
    end
    r.uniq
  end
  
end
