class String
  # Breaks a string up into an array based on a regular expression.
  # Similar to scan, but includes the matches.
  #
  #   require 'facet/string/shatter'
  #
  #   s = "<p>This<b>is</b>a test.</p>"
  #   s.shatter( // )
  #
  # _produces_
  #
  #   ["", "<p>", "This", "<b>", "is", "</b>", "a test.", "</p>"]
  #
  def shatter( re )
    self.gsub( re, "\1"+'\&'+"\1" ).split("\1")
  end 
end
