class String

  # Return the string with characters arranged in random order.
  #
  #   require 'facet/string/pick'
  #
  #   "Ruby rules".shuffle_chars  #=> "e lybRsuur"
  #
  def shuffle(separator=$/)
    split(separator).shuffle.join('')
  end

  # Destructive shuffle_chars.  Arrange the characters of the
  # string in a new random order.
  #
  #   require 'facet/string/pick'
  #
  #   s = "Ruby rules".shuffle_chars
  #   s.shuffle_chars!
  #   s    #=> "e lybRsuur"
  #
  def shuffle!(separator=$/)
    self.replace( shuffle(separator) )
  end
  
  # Return the string with characters arranged in random order.
  #
  #   require 'facet/string/pick'
  #
  #   "Ruby rules".shuffle_chars  #=> "e lybRsuur"
  #
  def shuffle_chars
    split(//).shuffle.join('')
  end

  # Destructive shuffle_chars.  Arrange the characters of the
  # string in a new random order.
  #
  #   require 'facet/string/pick'
  #
  #   s = "Ruby rules".shuffle_chars
  #   s.shuffle_chars!
  #   s    #=> "e lybRsuur"
  #
  def shuffle_chars!
    self.replace( shuffle_chars )
  end
  
end
