class String
  alias_method( :succ_once, :succ )
  
  # Allows #succ to take _n_ step increments.
  #
  #   require 'facet/string/succ'
  #
  #   "abc".succ      #=> "abd"
  #   "abc".succ(4)   #=> "abg"
  #   "abc".succ(24)  #=> "aca"
  #
  def succ(n=1)
    s = self
    n.times { s = s.succ_once }
    s
  end
end
