class String

  # Indent left or right by n spaces.
  # (This used to be called #tab and aliased as #indent.)
  #
  #   require 'facet/string/tab'
  #
  def indent(n)  
    if n >= 0
      gsub(/^/, ' ' * n)
    else
      gsub(/^ {0,#{-n}}/, "")
    end
  end
  
  # Aligns each line n spaces
  # this used to be #taballto.
  #
  #   require 'facet/string/tab'
  #
  def tab(n)
    gsub(/^ */, ' ' * n)
  end

  # Preserves relative tabbing.
  # The first non-empty line ends up with n spaces before nonspace.
  #
  #   require 'facet/string/tab'
  #
  def tabto(n)
    if self =~ /^( *)\S/
      indent(n - $1.length)
    else
      self
    end
  end
  
end
