class Symbol
  # Generates a new symbol that is unique among the 
  # method names of a given class or object. If no
  # parameter is given then Object class is assumed.
  #
  #   require 'facet/symbol/gen'
  #
  #   :class.gen => :clast
  #
  def gen( obj=nil )
    s = self.to_s
    if Class === obj
      while klass.method_defined?( s )
        s = s.succ
      end
    else
      while obj.respond_to?( s )
        s = s.succ
      end
    end
    return s.to_sym
  end
end 
