
require 'test/unit'
require 'facet/class/cattr'

# fixture

class Tester
  def initialize
    @@a = 10
  end
  def b
    @@b
  end
end

# testcase

class TC_Class < Test::Unit::TestCase
  
  # cattr

  def test_cattr_reader
    assert_nothing_raised {
      Tester.class_eval { cattr_reader :a }
    }
    t = Tester.new
    assert_equal( 10, t.a )
  end

  def test_cattr_writer
    assert_nothing_raised {
      Tester.class_eval { cattr_writer :b }
    }
    t = Tester.new
    t.b = 5
    assert_equal( 5, t.b )
  end
  
  def test_cattr_accessor
    assert_nothing_raised {
      Tester.class_eval { cattr_accessor :c }
    }
    t = Tester.new
    t.c = 50
    assert_equal( 50, t.c )
  end
  
end
