
require 'test/unit'

require 'facet/kernel/bug!'
require 'facet/kernel/here'
require 'facet/kernel/call_stack'
require 'facet/kernel/called'
require 'facet/kernel/demo'
require 'facet/kernel/fn'
require 'facet/kernel/get_by_id'
require 'facet/kernel/maybe'
require 'facet/kernel/require_local'
require 'facet/kernel/resc'


class TC_Kernel < Test::Unit::TestCase

  # bug!
  
  def test_bug!
    assert_raises(ScriptBug){ bug! "error test" }
  end

  # call_stack
  
  def test_call_stack
    assert_nothing_raised{ call_stack }
  end

  # called
  
  def test_called
    assert_equal( :test_called, called )    
  end
  
  def test_method_name
    # For some reason this was returning a string
    # even when aliased to #called! Why?
    # Well, I couldn't seem to fix it, so I just
    # accepted it as fact and made +method_name+ 
    # purposefully work that way.
    assert_equal( "test_method_name", method_name )
  end
  
  # demo
  
  def test_demo
    demo(i=''){%{ a = [1,2,3] }}
    o = " a = [1,2,3]             #=>  [1, 2, 3]\n"
    assert_equal( o, i )
  end
  
  # fn
  
  def test_fn
    assert_instance_of(Proc, fn{ |x| x + 1 } )
  end

  # get_by_id
  
  def test_get_by_id
    a = "Test"
    i = a.object_id
    assert_equal( a, get_by_id(i) )
  end
  
  # here
  
  def test_here
    assert_instance_of( Binding, here )
  end

  # maybe
  # to do
    
  # require_local

  def test_require_local
    require_local 'test_file'
  end
  
  # resc
  
  def test_resc
    assert_equal( Regexp.escape("'jfiw0[]4"), resc("'jfiw0[]4") )
    assert_equal( Regexp.escape("/////"), resc("/////") )
  end
  
end
