
require 'test/unit'

require 'facet/matchdata/match'
require 'facet/matchdata/match_from'


class TC_MatchData < Test::Unit::TestCase

  # match
  
  def test_match
    md = /X(a)(b)(c)X/.match("YXabcXY")
    assert_equal( "XabcX", md.match )
  end

  # match_from

  def test_pre_match_from
    md = /X(a)(b)(c)X/.match("YXabcXY")
    assert_equal( md.pre_match, md.pre_match_from )
    assert_equal( md.pre_match, md.pre_match_from(0) )
    assert_equal( "Y", md.pre_match_from )
    assert_equal( "Y", md.pre_match_from(0) )
    assert_equal( "YX", md.pre_match_from(1) )
    assert_equal( "YXa", md.pre_match_from(2) )
    assert_equal( "YXab", md.pre_match_from(3) )
    assert_equal( "YXab", md.pre_match_from(-1) )
    assert_equal( "YXa", md.pre_match_from(-2) )
    assert_equal( "YX", md.pre_match_from(-3) )
  end
  
  def test_post_match_from
    md = /X(a)(b)(c)X/.match("YXabcXY")
    assert_equal( md.post_match, md.post_match_from )
    assert_equal( md.post_match, md.post_match_from(0) )
    assert_equal( "Y", md.post_match_from )
    assert_equal( "Y", md.post_match_from(0) )
    assert_equal( "bcXY", md.post_match_from(1) )
    assert_equal( "cXY", md.post_match_from(2) )
    assert_equal( "XY", md.post_match_from(3) )
    assert_equal( "XY", md.post_match_from(-1) )
    assert_equal( "cXY", md.post_match_from(-2) )
    assert_equal( "bcXY", md.post_match_from(-3) )
  end
  
end 
