
require 'test/unit'

require 'facet/module/abstract'
require 'facet/module/by_name'
require 'facet/module/initializer'
require 'facet/module/redirect'


class TC_Module < Test::Unit::TestCase
  
  # abstract

  abstract :q
  
  def test_abstract
    assert_raises( TypeError ) { q }
  end

  # by_name
  
  def test_by_name
    c = ::Test::Unit::TestCase.name
    assert_equal( ::Test::Unit::TestCase, Module.by_name(c) )
    c = "Test::Unit::TestCase"
    assert_equal( ::Test::Unit::TestCase, Class.by_name(c) )
  end
   
  # initializer
  
  def test_attr_initializer
    cc = Class.new
    cc.class_eval{ 
      initializer :a
      attr_reader :a
    }
    c = cc.new(10)
    assert_equal( 10, c.a )
  end
  
  # redirect
  
  def a ; 1 ; end
  
  redirect :b => :a
  
  def test_redirect
    assert_equal( 1, b )
  end
  
end
