
require 'test/unit'

require 'facet/module/redefine_method'
require 'facet/module/wrap_method'


# fixture

class Mockery

  def fixture_method_a; "a"; end
  def fixture_method_b; "b"; end

  def fixture_method_c; "c"; end
  def fixture_method_d; "d"; end

  redefine_method( :fixture_method_a ) { nil }  
  redefine_method( :fixture_method_b ) { "x" }
  
  wrap_method( :fixture_method_c ) { |old| old.call }
  wrap_method( :fixture_method_d ) { |old| old.call + "e" }
      
end


# testcase

class TC_Module < Test::Unit::TestCase 

  # redefine_method
    
  def test_redef
    m = Mockery.new
    assert_equal( "a", m.fixture_method_a )    
    assert_equal( "x", m.fixture_method_b )
  end
  
  # wrap_method
  
  def test_wrap
    m = Mockery.new
    assert_equal( "c", m.fixture_method_c )
    assert_equal( "de", m.fixture_method_d )
  end

end
