
require 'test/unit'

require 'facet/object/supers'


# setup

class A
  def x; "A.x"; end
  def y; "A.y"; end
end

class B < A
  def x; "B.x" end
  def y; "B.y" end
end

class C < B
  def x; "C.x"; end
  def y; supers.x ; end
end


class Foo
  def foo
    return "Foo#foo"
  end
end

class Bar < Foo
  def foo
    return "Bar#foo"
  end
end


class TC_Object < Test::Unit::TestCase

  def setup
    @c = C.new
  end

  def test_supers
    assert_equal("B.x", @c.y)
    assert_equal("C.x", @c.x)
  end

  def test_super_method
    b = Bar.new
    assert_equal "Bar#foo", b.foo
    assert_equal "Bar#foo", b.instance_eval { super_method(Bar, :foo).call }
    assert_equal "Foo#foo", b.instance_eval { super_method(Foo, :foo).call }
  end

  def test_super_send
    b = Bar.new
    assert_equal "Bar#foo", b.foo
    assert_equal "Bar#foo", b.instance_eval { super_send(Bar, :foo) }
    assert_equal "Foo#foo", b.instance_eval { super_send(Foo, :foo) }
  end

end
