
require 'test/unit'

require 'facet/proc/compose'
require 'facet/proc/to_method'


class TC_Proc < Test::Unit::TestCase

  # compose

  def test_compose
    a = lambda { |x| x + 4 }
    b = lambda { |y| y / 2 }
    assert_equal( 6, (a.compose(b)).call(4) )
    assert_equal( 4, (b.compose(a)).call(4) )
    assert_equal( 6, (a * b).call(4) )
    assert_equal( 4, (b * a).call(4) )
  end
  
  # to_method
  
  def test_to_method
    a = 2
    tproc = proc { |x| x + a }  
    tmethod = tproc.to_method(:tryit)
    assert_equal( 3, tmethod.call(1) )
    assert_respond_to( self, :tryit )
    assert_equal( 3, tryit(1) )
  end
  
end
