
require 'test/unit'

require 'facet/regexp/arity'
require 'facet/regexp/to_re'


class TC_Regexp < Test::Unit::TestCase

  # arity
  
  def test_arity
    r = /(1)(2)(3)/
    assert_equal( 3, r.arity )
    r = /(1)(2)(3)(4)/
    assert_equal( 4, r.arity )
    r = /(1)(2)((a)3)/
    assert_equal( 4, r.arity )
    r = /(?#nothing)(1)(2)(3)(?=3)/
    assert_equal( 3, r.arity )
  end
  
  # to_re
  
  def test_to_re
    r = /0..10/
    assert_equal( r, r.to_re )
  end
  
  def test_to_regexp
    r = /0..10/
    assert_equal( r, r.to_regexp )
  end
  
end
