
require 'test/unit'

require 'facet/time/custom_format'
require 'facet/time/elapse'


class TC_Time < Test::Unit::TestCase

  # custom_format
  
  def test_custom_format
    time = Time.parse('2/3/2004 15:37')
    cf = time.custom_format('#DDDD#, #MMMM# #D##th# @ #h#:#mm##ampm#')
    assert_equal( 'Tuesday, February 3rd @ 3:37pm', cf )
    cf = time.custom_format('#YYYY#-#MMM#-#D#')
    assert_equal( '2004-Feb-3', cf )
    cf = time.custom_format('#MM#/#DD#/#YY#')
    assert_equal( '02/03/04', cf )
  end
  
  # elapse

  def test_elpase
    t = Time.elapse { sleep 1 }
    assert_equal( 1, (t + 1).to_i )
  end

end

